// CopySpdBench.cpp : R\[ AvP[ṼGg |Cg`܂B
//
// MyDiskTest.cpp : R\[ AvP[ṼGg |Cg`܂B
//
#include "stdafx.h"

#include <iostream>
#include <windows.h>
#include <sstream>
#include <time.h>
#include <conio.h>
#include <fstream>

#pragma comment(lib,"winmm.lib")

using namespace std;


string sFromFileHeader = "test\\test";
string sToFileHeader   = "test\\copy";

BOOL DeleteDirectory( LPCTSTR lpPathName )
{
	// ͒l`FbN
	if( NULL == lpPathName )
	{
		return FALSE;
	}

	// fBNg̕ۑiI['\'ȂȂtj
	TCHAR szDirectoryPathName[_MAX_PATH];
	_tcsncpy_s( szDirectoryPathName, _MAX_PATH, lpPathName, _TRUNCATE );
	if( '\\' != szDirectoryPathName[_tcslen(szDirectoryPathName) - 1] )
	{	// ԍŌ'\'ȂȂtB
		_tcsncat_s( szDirectoryPathName, _MAX_PATH, _T("\\"), _TRUNCATE );
	}

	// fBNg̃t@Cp̃t@C쐬
	TCHAR szFindFilePathName[_MAX_PATH];
	_tcsncpy_s( szFindFilePathName, _MAX_PATH, szDirectoryPathName, _TRUNCATE );
	_tcsncat_s( szFindFilePathName, _MAX_PATH, _T("*"), _TRUNCATE );

	// fBNg̃t@CJn
	WIN32_FIND_DATA		fd;
	HANDLE hFind = FindFirstFile( szFindFilePathName, &fd );
	if( INVALID_HANDLE_VALUE == hFind )
	{	// ΏۃtH_݂ȂB
		return FALSE;
	}

	do
	{
		if( '.' != fd.cFileName[0] )
		{
			TCHAR szFoundFilePathName[_MAX_PATH];
			_tcsncpy_s( szFoundFilePathName, _MAX_PATH, szDirectoryPathName, _TRUNCATE );
			_tcsncat_s( szFoundFilePathName, _MAX_PATH, fd.cFileName, _TRUNCATE );

			if( FILE_ATTRIBUTE_DIRECTORY & fd.dwFileAttributes )
			{	// fBNgȂċNĂяoō폜
				if( !DeleteDirectory( szFoundFilePathName ) )
				{
					return FALSE;
				}
			}
			else
			{	// t@CȂWin32API֐pč폜
				if( !DeleteFile( szFoundFilePathName ) )
				{
					return FALSE;
				}
			}
		}
	} while( FindNextFile( hFind, &fd ) );

	FindClose( hFind );

	return RemoveDirectory( lpPathName );
}

//nFileSizeKBP
bool Init(int nFileSize, int nFileNum)
{
	BOOL result;
	int BufSize = 1024; //1KB

	char *buf = new char[BufSize];
	char sFileNameFrom[100];

	for (int j=0; j<nFileNum; ++j) {
		int temp = BufSize / 2;
		for(int i=0;i< temp;i++){
			memset((buf + i*2), rand(), 2);
		}
		sprintf_s(sFileNameFrom, sizeof(sFileNameFrom), "%s%d.dat", sFromFileHeader.c_str(), j);
		HANDLE hFile = ::CreateFile(sFileNameFrom, GENERIC_READ|GENERIC_WRITE, 0, NULL, CREATE_ALWAYS,
				FILE_ATTRIBUTE_NORMAL|FILE_FLAG_NO_BUFFERING|FILE_FLAG_SEQUENTIAL_SCAN, NULL);

		if(hFile == INVALID_HANDLE_VALUE){
			cout << " CreateFile Error:INVALID_HANDLE_VALUE" << endl;
			delete [] buf;
			return false;
		}
		USHORT lpInBuffer = COMPRESSION_FORMAT_NONE;
		DWORD lpBytesReturned = 0;
		DeviceIoControl(hFile, FSCTL_SET_COMPRESSION, (LPVOID) &lpInBuffer,
					sizeof(USHORT), NULL, 0, (LPDWORD)&lpBytesReturned, NULL);

		DWORD writesize;
		for(int i = 0;i < nFileSize; ++i){
			result = WriteFile(hFile, buf, BufSize, &writesize, NULL);
		}
		CloseHandle(hFile);

		if(result == 0){
			cout << " WriteFile Error" << endl;
			delete[] buf;
			return false;
		}
	}
	delete[] buf;
	return true;
}

void DeleteTargetFile (int nFileNum) {
	char sFileNameTo[100];
	for (int i=0; i<nFileNum; ++i) {
		sprintf_s(sFileNameTo, sizeof(sFileNameTo), "%s%d.dat", sToFileHeader.c_str(), i);
		DeleteFile(sFileNameTo);
	}
}

DWORD CopyTest(int nFileSize, int nFileNum) {

	char sFileNameFrom[100];
	char sFileNameTo[100];

	cout << "Preparing...";
	CreateDirectory("test", NULL);
	if (!Init(nFileSize, nFileNum)) {
		cout << "Init Failed" << endl;
		return 0;
	}
	cout << " Testing...";
	DWORD First = timeGetTime();
	for (int i=0; i<nFileNum; ++i) {
		sprintf_s(sFileNameTo, sizeof(sFileNameTo), "%s%d.dat", sToFileHeader.c_str(), i);
		sprintf_s(sFileNameFrom, sizeof(sFileNameFrom), "%s%d.dat", sFromFileHeader.c_str(), i);
		if (!CopyFile(sFileNameFrom, sFileNameTo, FALSE)) {
			cout << "Copy Failed!" << endl;
			return 0;
		}
	}
	DWORD Last = timeGetTime();
	DeleteDirectory("test");
	cout << " Done.";
	return Last-First;
}

bool CopyBench(const string& sFileSize, int nFileNum, int nTrial, ofstream &outResult) {

	int nFileSize;
	char cType = sFileSize[sFileSize.length()-1];
	if ((cType == 'k') || (cType == 'K')) {
		nFileSize = (int)(atof(sFileSize.c_str()));
	}
	else if ((cType == 'm') || (cType == 'M')) {
		nFileSize = (int)(atof(sFileSize.c_str())*1024);
	}
	else if ((cType == 'g') || (cType == 'G')) {
		nFileSize = (int)(atof(sFileSize.c_str())*1024*1024);
	}
	else {
		cout << "Size Type Must Be \'K\' or \'M\' or \'G\'." << endl;
		return false;
	}
	cout << sFileSize << " " << nFileNum << "Files " << nTrial << "Trial" << endl;
	outResult << sFileSize << " " << nFileNum << "Files " << nTrial << "Trial : " ;
	double res;
	double resMB;
	double resTotal = 0;
	int nSucceeded = 0;
	for (int i=0; i<nTrial; ++i) {
		cout << "[Trial " << i << "] ";
		res = CopyTest(nFileSize, nFileNum) / 1000.0;
		if (res != 0) {
			resMB = (nFileSize/1024.0*nFileNum) / res;
			cout << "  Result: " << res << " sec : " << resMB << " MB/s" << endl; 
			resTotal += res;
			++nSucceeded;
		}
	}
	if (nSucceeded > 0) {
		cout << "Average: " << resTotal/nSucceeded << " sec : " << (nFileSize/1024.0*nFileNum*nSucceeded)/resTotal << "MB/s" << endl;
		outResult << "Average: " << resTotal/nSucceeded << " sec : " << (nFileSize/1024.0*nFileNum*nSucceeded)/resTotal << "MB/s" << endl;
		return true;
	}
	else return false;
}


void main()
{
	srand((unsigned int)time(0));
	
	DeleteDirectory("test");
	ofstream ofs("result.txt");
	ifstream ifs("CopySpdBench.ini");
	if (ifs) {
		cout << "CopySpdBench Build: [" << __TIMESTAMP__ << "]" << endl;
		ofs << "CopySpdBench Build: [" << __TIMESTAMP__ << "]" << endl;
		string line;
		while (getline(ifs, line)) {
			if ( !line.empty() && (line[0] != '#')) {
				char sFileSize[100];
				int nFileNum;
				int nTrial;
				int nRes = sscanf_s(line.c_str(), "%s %d %d\n", sFileSize, sizeof(sFileSize), &nFileNum, &nTrial);
				if (nRes == 3)  {
					CopyBench(sFileSize, nFileNum, nTrial, ofs);
				}
				else {
					cout << "ini error: " << line << endl;
				}
			}
		}
	}
	else {
		cout << "CopySpdBench.ini NOT Found." << endl;
		CopyBench("4K", 5000, 5, ofs);
	}

	cout << "Press Any Key to Finish." << endl;
	_getch();
}